// PROCE55 node.js service
//
var http = require('http');

// Custom functions:
var CUSTOM = require('./_function_defs.js');
//var UPCfunctions = require('./UPCfunctions.js');
var server_port_number = 80;

var ip = require("ip");
console.log ( "PROCE55 Application Server listening on: " + ip.address() + ":" + server_port_number );

http.createServer(function(request, response) {

  var headers = request.headers;
  var method = request.method;
  var url = request.url;
  var body = [];
  //var userAgent = headers['user-agent']; // headers always low-case!
  //console.log("Method: " + method + ", URL: " + url + ", agent: " + userAgent);
  
  request.on('error', function(err) {
    console.error(err);      
  }).on('data', function(chunk) {
    body.push(chunk);
  }).on('end', function() {
    body = Buffer.concat(body).toString();
    
  response.on('error', function(err) {
    console.error(err);
  });
    
  // process JSON request
  var client_resp = processJSONRequest(body.trim());
  console.log("Returning response.");
  //
  response.statusCode = 200;
  response.setHeader('Content-Type', 'application/json');
  response.setHeader('Access-Control-Allow-Origin', '*');
  response.write(JSON.stringify(client_resp));
  response.end();
  
  });
}).listen(server_port_number);

// ----------------------------------------------------

function processJSONRequest(request) {
  var response = "";
  console.log("======================\r\nProcessing JSON request: " + request);
  // ..
  try {
    var msg = JSON.parse(request);
    // Send the P55Message object to the function specified:
// if PREFIX then...
// msg.FunctionName UPCfunctions.GetUPCData  
//    response = eval(msg.FunctionName + "(msg)");
// else ...
    response = eval("CUSTOM." + msg.FunctionName + "(msg)");
    console.log("====================");
  }
  catch (err) {
    console.log("Error: " + err.toString());
    response = "";  
  }
  return response;
}